// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AnimationEffect.pas' rev: 6.00

#ifndef AnimationEffectHPP
#define AnimationEffectHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <EffectUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Animationeffect
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TMathPoint
{
	float X;
	float Y;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TMatrix
{
	float M11;
	float M12;
	float M13;
	float M21;
	float M22;
	float M23;
	float M31;
	float M32;
	float M33;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TSpikeData
{
	TMathPoint TriangleEnd[3][16];
	TMathPoint EndCenter[16];
	TMathPoint TriangleCenter[16];
	TMatrix MatrixCircle[16];
} ;
#pragma pack(pop)

#pragma option push -b-
enum TAnimationType { atInit, atDraw, atErase };
#pragma option pop

#pragma option push -b-
enum TAnimationEffectType { etRandom, etSpin, etVortex, etScatterGather, etSpike, etFireworks };
#pragma option pop

class DELPHICLASS TAnimationEffect;
class PASCALIMPLEMENTATION TAnimationEffect : public Effectutils::TFormAnimationEffect 
{
	typedef Effectutils::TFormAnimationEffect inherited;
	
private:
	Word FDelay;
	Byte FFrames;
	Byte FFireworkBlasts;
	TAnimationEffectType FEffectType;
	Byte FSteps;
	HDC DrawDC;
	float EffectParam;
	TMatrix GlobalMatrix;
	TMathPoint FireworksData[256];
	int AfterImages;
	int TotalSteps;
	int Step;
	TMathPoint RightTop;
	TMathPoint Center;
	TSpikeData SpikeData;
	TAnimationEffectType CurrentEffect;
	void __fastcall Animate(bool Open);
	void __fastcall AnimationSelect(TAnimationType AnimationType);
	void __fastcall efSpinFrame(TAnimationType AnimationType);
	void __fastcall efVortexFrames(TAnimationType AnimationType);
	void __fastcall efScatterGatherFrames(TAnimationType AnimationType);
	void __fastcall efSpikeFrames(TAnimationType AnimationType);
	void __fastcall efFireworxFrames(TAnimationType AnimationType);
	
protected:
	virtual void __fastcall DoAnimateOnShow(void);
	virtual void __fastcall DoAnimateOnHide(void);
	
public:
	__fastcall virtual TAnimationEffect(Classes::TComponent* aOwner);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property AnimateOnShow  = {default=0};
	__property AnimateOnHide  = {default=0};
	__property Word Delay = {read=FDelay, write=FDelay, default=100};
	__property Byte FireworkBlasts = {read=FFireworkBlasts, write=FFireworkBlasts, default=10};
	__property Byte Frames = {read=FFrames, write=FFrames, default=6};
	__property TAnimationEffectType EffectType = {read=FEffectType, write=FEffectType, default=0};
	__property Byte Steps = {read=FSteps, write=FSteps, default=50};
public:
	#pragma option push -w-inl
	/* TFormAnimationEffect.Destroy */ inline __fastcall virtual ~TAnimationEffect(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint DEF_AE_DELAY = 0x64;
static const Shortint DEF_AE_FIREWORKBLASTS = 0xa;
static const Shortint DEF_AE_FRAMES = 0x6;
static const Shortint DEF_AE_STEPS = 0x32;

}	/* namespace Animationeffect */
using namespace Animationeffect;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AnimationEffect
